OGRE-Next: Ogre::GLSLESProgramPipelineManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::GLSLESProgramPipelineManager Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state. More...

`#include <OgreGLSLESProgramPipelineManager.h>`

Inheritance diagram for Ogre::GLSLESProgramPipelineManager:
[legend]

## Public Member Functions
| GLSLESProgramPipelineManager ()
| ~GLSLESProgramPipelineManager ()
GLSLESProgramPipeline * | getActiveProgramPipeline ()
| Get the program pipeline that combines the current program objects.
void | setActiveFragmentShader (GLSLESShader *fragmentShader)
void | setActiveVertexShader (GLSLESShader *vertexShader)
| Set the active vertex and fragment link programs for the next rendering state.
Public Member Functions inherited from Ogre::GLSLESProgramManagerCommon
| GLSLESProgramManagerCommon ()
| ~GLSLESProgramManagerCommon ()
void | extractUniformsFromGLSL (const String &src, GpuNamedConstants &constantDefs, const String &filename)
| Populate a list of uniforms based on GLSL source and store them in GpuNamedConstants.
void | extractUniformsFromProgram (GLuint programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &uniformList, GLUniformBufferList &uniformBufferList)
| Populate a list of uniforms based on an OpenGL program object.
void | optimiseShaderSource (GLSLESShader *gpuProgram)
Public Member Functions inherited from Ogre::Singleton< GLSLESProgramPipelineManager >
| ~Singleton ()

## Static Public Member Functions
static GLSLESProgramPipelineManager & | getSingleton ()
static GLSLESProgramPipelineManager * | getSingletonPtr ()
Static Public Member Functions inherited from Ogre::Singleton< GLSLESProgramPipelineManager >
static GLSLESProgramPipelineManager & | getSingleton ()
static GLSLESProgramPipelineManager * | getSingletonPtr ()

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state.

GLSL vertex and fragment program objects are compiled separately and then attached to a program object and then the program pipeline object is linked. Since Ogre can only handle one vertex program stage and one fragment program stage being active in a pass, the GLSL ES Program Pipeline Manager does the same. The GLSL ES Program Pipeline Manager acts as a state machine and activates a pipeline object based on the active vertex and fragment program. Previously created pipeline objects are stored along with a unique key in a hash map for quick retrieval the next time the pipeline object is required.

## Constructor & Destructor Documentation

## ◆ GLSLESProgramPipelineManager()

Ogre::GLSLESProgramPipelineManager::GLSLESProgramPipelineManager | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~GLSLESProgramPipelineManager()

Ogre::GLSLESProgramPipelineManager::~GLSLESProgramPipelineManager | ( |  | ) |

## Member Function Documentation

## ◆ getActiveProgramPipeline()

GLSLESProgramPipeline * Ogre::GLSLESProgramPipelineManager::getActiveProgramPipeline | ( |  | ) |

Get the program pipeline that combines the current program objects.

If the program pipeline object was not already created a new one is created.

## ◆ getSingleton()

GLSLESProgramPipelineManager & Ogre::GLSLESProgramPipelineManager::getSingleton | ( |  | ) |
| static

References GLSLESProgramPipelineManager().

## ◆ getSingletonPtr()

GLSLESProgramPipelineManager * Ogre::GLSLESProgramPipelineManager::getSingletonPtr | ( |  | ) |
| static

References GLSLESProgramPipelineManager().

## ◆ setActiveFragmentShader()

void Ogre::GLSLESProgramPipelineManager::setActiveFragmentShader | ( | GLSLESShader * | fragmentShader | ) |

## ◆ setActiveVertexShader()

void Ogre::GLSLESProgramPipelineManager::setActiveVertexShader | ( | GLSLESShader * | vertexShader | ) |

Set the active vertex and fragment link programs for the next rendering state.

The active program pipeline object will be cleared. Normally called from the GLSLESShader::bindProgram and unbindProgram methods.

The documentation for this class was generated from the following file:

- OgreGLSLESProgramPipelineManager.h